<template>
	<div :id="id" :class="$style.animatedGraphics">
		<span :class="$style.topBorder" />
		<div :class="$style.container">
			<MoleculeFadingTitle :class="$style.heading" :title="heading" />
			<div
				v-for="(graphic, index) in items"
				:key="index"
				:style="{
					'--animation-duration': `${graphic.animationDuration || 6}s`,
					'--animation-delay': `${graphic.animationDelay || 1}s`,
					'--scale-start': graphic.scaleStart || 1,
					'--scale-end': graphic.scaleEnd || 1,
					'--x-pos-start': `${graphic.xPosStart || -10}vw`,
					'--x-pos-end': `${graphic.xPosEnd || 100}vw`,
					'--width-mobile': `${graphic.widthMobile || 200}px`,
					'--top-offset-mobile': graphic.topOffsetMobile || null,
					'--right-offset-mobile': graphic.rightOffsetMobile || null,
					'--bottom-offset-mobile': graphic.bottomOffsetMobile || null,
					'--left-offset-mobile': graphic.leftOffsetMobile || null,
					'--transform-origin-mobile': graphic.transformOriginMobile || 'center',
					'--width-desktop': `${graphic.widthDesktop || 319}px`,
					'--top-offset-desktop': graphic.topOffsetDesktop || null,
					'--right-offset-desktop': graphic.rightOffsetDesktop || null,
					'--bottom-offset-desktop': graphic.bottomOffsetDesktop || null,
					'--left-offset-desktop': graphic.leftOffsetDesktop || null,
					'--transform-origin-desktop': graphic.transformOriginDesktop || 'center',
					'--animation-play-state': animationPlayState,
				}"
				:class="$style.graphic"
			>
				<BaseImage
					:image="graphic.image"
					:class="$style.graphicImage"
					:aspect="1"
					contain
					compression-level="medium"
					:sizes="`(min-width: ${$style.mediumBreakpoint}) ${graphic.widthDesktop || 319}px, ${
						graphic.widthMobile || 319
					}px`"
				/>
				<div v-if="graphic.label && graphic.description" :class="$style.graphicText">
					<div v-if="graphic.label" :class="$style.graphicLabel">{{ graphic.label }}</div>
					<div v-if="graphic.description" :class="$style.graphicDescription">{{ graphic.description }}</div>
				</div>
			</div>
		</div>
		<span :class="$style.border" />
	</div>
</template>

<script>
import MoleculeFadingTitle from '@components/molecule-fading-title';

export default {
	components: { MoleculeFadingTitle },

	props: {
		id: {
			type: String,
			default: null,
		},

		heading: {
			type: String,
			default: '',
		},

		items: {
			type: Array,
			default: () => [],
		},
	},

	data: () => ({ animationPlayState: 'paused' }),

	mounted() {
		this.$nextTick(() => (this.animationPlayState = 'running'));
	},
};
</script>

<style lang="scss" module>
@import '@design';

@keyframes breath {
	0% {
		transform: translate(var(--x-pos-start)) scale(var(--scale-start));
	}
	100% {
		transform: translate(var(--x-pos-end)) scale(var(--scale-end));
	}
}

.animatedGraphics {
	@include above('medium') {
		padding: 2.3rem 0;
	}
}

.border {
	display: block;
	width: calc(100% - 9rem);
	height: 1px;
	margin: 0 4.5rem;
	background: color('primary-250');

	@include above('medium') {
		width: calc(100% - 16rem);
		margin: 0 8rem;
	}
}

.topBorder {
	composes: border;

	@include below('medium') {
		display: none;
	}
}

.container {
	position: relative;
	padding: 20.4rem 4.8rem;
	overflow: hidden;

	@include above('medium') {
		padding: 20.2rem 8rem;
	}
}

.heading {
	@include use-text-style('heading-500');

	position: relative;
	z-index: 1;
	font-family: font-family('secondary');
	line-height: 1.1765;
	text-align: center;

	@include above('medium') {
		@include use-text-style('heading-900');

		padding: 0.8em 0;
		line-height: 1.1333333333;
	}
}

.graphic {
	position: absolute;
	top: var(--top-offset-mobile);
	left: var(--left-offset-mobile);
	z-index: 0;
	display: flex;
	flex-direction: column;
	align-items: center;
	text-align: center;
	transform-origin: var(--transform-origin-mobile);
	animation: breath var(--animation-duration) linear var(--animation-delay) infinite;
	animation-play-state: var(--animation-play-state);
	will-change: transform;

	@include above('medium') {
		top: var(--top-offset-desktop);
		right: var(--right-offset-desktop);
		bottom: var(--bottom-offset-desktop);
		left: var(--left-offset-desktop);
		transform-origin: var(--transform-origin-desktop);
	}
}
.graphicImage {
	width: var(--width-mobile);

	@include above('medium') {
		width: var(--width-desktop);
	}
}
.graphicText {
	position: relative;
}

.graphicLabel {
	@include use-text-style('heading-100');

	font-family: font-family('secondary');

	@include above('medium') {
		padding: 0;
	}
}

.graphicDescription {
	@include use-text-style('type-100');

	font-weight: 300;
}
</style>
